# Changelog

## 5.0.0-dev.1 - Flexibility is key

**This version consists primarily of *breaking changes*.**

- Move many files to new Flex package
  + `expose` library
  + `lib/analysis_options.yaml`
  + `lang.dart`
  + `patient_stream_queue.dart`
  + `prompt.dart`
  + `state.dart`
  + `util.dart`
  + extension files
- `RequestInputEvent` and `ILog.logRequestInput` no longer accepts a long message or level
- Improve log function documentation
- Fix `Localizations` pipe operator logic
- Rewrite `Locale` and `Language`
- `mockito` is now a dev dependency instead of a dependency
- `test` is now a dev dependency instead of a dependency
- `test_api` is now a dependency

<!-- TODO(mpfaff): Complete changelog -->


**Please ignore the hideous versioning beyond this point.**


## 4.0.0+5

- Fix formatting of some documentation


## 4.0.0+4

- Run `dartfmt` on all files


## 4.0.0+3

- Fix formatting of some documentation


## 4.0.0+2

- Add `test` to regular dependency section due to use of `TestFailure` within `RootModule`
- Update `test` dependency to 1.9.4


## 4.0.0+1

- Add MarkdownLint configuration file
- Remove boilerplate `StreamQueueObservable` code and reimplement directly in `PatientStreamQueue`
- Refactor most `Locale` constants
- Add a few more languages, countries and locales
- Document entire library
- Migrate to RXDart 0.23
- Add DartX dependency
- Add Mockito dependency for testing stdout
- Add example along with a launch configuration for it
- Remove deprecated `echoPrompt` and `securePrompt`
- Add `echo` parameter to `prompt` amd `promptSync`
- Refactor `dtfmt` to `iso8601NoTZ`
- Refactor `Level(...)` to `Level._(...)`
- Rename all documentation references of alpha package names including Flow and Ocean to Plexus
- Remove `KernelSignal`
- RootModule now watches for some process signals
- RootModule internal initialization functions are now private
- Refactor a bunch of `typedef`
- Refactor basically everything else
- Logging \*works\* (some things are still broken. queue many bug reports)

**There are probably some documentation comments that were copy-pasted early on and have not been update. If you come across these, *please* file a bug report**


## 3.0.0+1

- Complete core localization implementation


## 2.1.2+2

- Minor documentation and syntax updates


## 2.1.2

- Fix type check in logging
- Add log test


## 2.1.1

- Add debug flag to prompts which prints input when true


## 2.1.0

- Fix formatting in `CHANGELOG.md`
- Change `UnmodifiableMapMixin` to be a `mixin` instead of `abstract class`


## 2.0.0

- Yeah... just tons of changes. Sorry fellas.


## Somewhere Between

- Primarily use `package:io` instead of `dart:io`
- Prompting is now asynchronous by default


## 1.0.0

- Where it all began
